#pragma once

#include <openssl/aes.h>
#include <openssl/rsa.h>
#include <openssl/evp.h>
#include <openssl/rand.h>
#include <openssl/err.h>

class CIkAES
{
public:
	enum { IKAES_CRYPT_KEY_SIZE			= 16 };
	enum { IKAES_CRYPT_BLOCK_SIZE		= 16 };

private:
	enum { IKAES_CRYPT_IV_SIZE			= 16 };
	
	BYTE m_key[IKAES_CRYPT_KEY_SIZE];
	BYTE m_iv[IKAES_CRYPT_IV_SIZE];

//	EVP_CIPHER_CTX m_ctx;
//	EVP_CIPHER_CTX m_ctxd;

public:
	CIkAES(void);
	~CIkAES(void);
	
	int GenerateNewCryptKey();

	const BYTE * GetCryptKey();
	bool SetCryptKey(const BYTE * pKey);

	const BYTE * GetInitialVector();
	bool SetInitialVector(const BYTE * pKey);

	int Encrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer);
	int Decrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer);
	
	int EncryptedSizeGuess(int nSourceDataSize);
};

inline
int CIkAES::EncryptedSizeGuess(int nSourceDataSize)
{
    return nSourceDataSize + IKAES_CRYPT_BLOCK_SIZE - (nSourceDataSize % IKAES_CRYPT_BLOCK_SIZE);
}
